#!/usr/bin/python
# textgridtier2csv.py D. Gibbon 2015.02.12

# Description: Convert long, short and csv format Praat information

#----------------------------------------------------------
# Import standard modules

import os, re, sys

#----------------------------------------------------------
# Input TextGrid from CLII

if len(sys.argv) < 3:
	print "Usage:",sys.argv[0],'<filename> <tiername>'
	exit()
fname = sys.argv[1]
tname = sys.argv[2]
if not os.path.isfile(fname):
	print "File",fname,"does not exist."
	exit()

textgrid = open(fname,'r').read().split('\n')
fname = sys.argv[1].split('.')[0]

#----------------------------------------------------------
# Remove initial and final spaces

nugrid = []
for l in textgrid:
	a = ''
	l = re.sub(' *$','',l)
	l = re.sub('^ *','',l)
	l = re.sub('\"','',l)
	if l != '':
		nugrid += [l]

#----------------------------------------------------------
# Parse TextGrid for tiers-interval tuples

def extracttiers(nugrid,outflag):
	tierkey = ''
	returnstring = ''
	output = ''
	val = ''
	start = 0
	if not outflag in ['file','string']:
		tierkey = outflag

	for i in range(len(nugrid)):
		l1 = nugrid[i].split(' = ')
		if len(l1) > 1:
			val = l1[1]
		if val == 'IntervalTier':
				if start > 0:
					if tierkey == tiername:
						return output
					if outflag == 'file':
						open(fname+'-'+tiername+'.csv','w').write(output)
					returnstring += output
				output = ''
				tiername = nugrid[i+1].split(' = ')[1]
				start = 1
		l2 = nugrid[i].split(' ')
		if l2[0] == 'intervals':
			xmin = nugrid[i+1].split(' = ')[1]
			xmax = nugrid[i+2].split(' = ')[1]
			text = nugrid[i+3].split(' = ')[1]
			dur = str(float(xmax)-float(xmin))
			interval = tiername+'\t'+text+'\t'+xmin+'\t'+xmax+'\t'+dur+'\t'+fname+'\n'
			output += interval
	if outflag == 'file':
		open(fname+'-'+tiername+'.csv','w').write(output)
	if outflag == 'string':
		returnstring += output
		return returnstring
	else:
		return ''

print extracttiers(nugrid,tname)

